/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <stdio.h>
#include "variables.h"
#include "utils.h"
#include "frac.h"
#include "superscript.h"
#include "subscript.h"
#include "sqrt.h"
#include "sum.h"
#include "prod.h"
#include "brace.h"
#include "int.h"
#include "oint.h"
#include "array.h"

void
drawInternal (char ***screen, struct Tgraph *graph, int x, int y)
{
  int kid = 0, curx = x, cury = y + (graph->dim.y - 1) - graph->dim.baseline;
  char *txt = graph->txt;
  while (*txt)
    {
      if (*txt == 1)
	{
	  txt++;
	  if (*txt == 1)	/* \frac */
	    drawFrac (&kid, &curx, &cury, screen, graph);
	  if (*txt == 2)	/* \superscript */
	    drawSuperscript (&kid, &curx, &cury, screen, graph, txt);
	  if (*txt == 3)	/* \subscript */
	    drawSubscript (&kid, &curx, &cury, screen, graph, txt);
	  if (*txt == 4)	/* \sqrt */
	    drawSqrt (&kid, &curx, &cury, screen, graph);
	  if (*txt == 5)	/* \sum */
	    drawSum (&kid, &curx, &cury, screen, graph);
	  if (*txt == 6)	/* \prod */
	    drawProd (&kid, &curx, &cury, screen, graph);
	  if (*txt == 7)	/* brace, print the following char in vertical */
	    {
	      drawBrace (&kid, &curx, &cury, screen, graph, txt);
	      txt++;
	    }
	  if (*txt == 8)	/* \int */
	    drawInt (&kid, &curx, &cury, screen, graph);
	  if (*txt == 9)	/* \oint */
	    drawOint (&kid, &curx, &cury, screen, graph);
	  if (*txt == 10)	/* array */
	    drawArray (&kid, &curx, &cury, screen, graph);
	}
      else
	(*screen)[cury][curx++] = *txt;
      txt++;
    }
}

char **
draw (struct Tgraph *graph)
{
  char **screen = (char **) malloc (sizeof (char *) * (graph->dim.y));
  int i, j;
  for (i = 0; i < graph->dim.y; i++)
    {
      screen[i] = (char *) malloc (graph->dim.x + 1);
      for (j = 0; j < graph->dim.x; j++)
	screen[i][j] = ' ';
      screen[i][graph->dim.x] = 0;
    }
  drawInternal (&screen, graph, 0, 0);
  return screen;
}
