/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <stdio.h>
#include <string.h>
#include "variables.h"
#include "utils.h"
#include "frac.h"
#include "dim.h"

int
dimFrac (char *found, char **Gpos, Tdim * Our, struct Tgraph *graph)
{
  Tdim out;
  char *start, *end, *tmp;
#define our (*Our)
#define gpos (*Gpos)
  int height = 0, width = 0;

  *gpos = 1;			/* mark the frac{} position as #1#1 */
  gpos++;
  *gpos = 1;
  gpos++;
  *gpos = 0;

  start = strchr (found, '{');
  end = findClosingBrace (start + 1);
  *end = 0;
  tmp = strdup (start + 1);
  *end = '}';

  out = dim (tmp, newChild (graph));
  free (tmp);
  height += out.y;
  width = out.x;

  start = strchr (end, '{');
  end = findClosingBrace (start + 1);
  *end = 0;
  tmp = strdup (start + 1);
  *end = '}';
  out = dim (tmp, newChild (graph));
  free (tmp);

  if (out.y > our.baseline)
    {
      our.y += out.y - our.baseline;
      our.baseline = out.y;	/* baseline+(out.y-baseline) */
    }
  if (height > our.y - our.baseline - 1)
    {
      our.y += height - (our.y - our.baseline - 1);
    }
  if (out.x > width)
    our.x += out.x;
  else
    our.x += width;

  if (our.baseline < out.y)
    our.baseline = out.y;
  return end - (found);		/* skip parsed text */
#undef our
#undef gpos
}

void
drawFrac (int *Kid, int *Curx, int *Cury, char ***screen, struct Tgraph *graph)
{
#define kid (*Kid)
#define curx (*Curx)
#define cury (*Cury)
  int width = graph->down[kid]->dim.x;
  int i;
  if (width < graph->down[kid + 1]->dim.x)
    width = graph->down[kid + 1]->dim.x;
  drawInternal (screen, graph->down[kid], curx + width / 2 - (graph->down[kid]->dim.x) / 2, cury - (graph->down[kid]->dim.y));
  drawInternal (screen, graph->down[kid + 1], curx + width / 2 - (graph->down[kid + 1]->dim.x) / 2, cury + 1);
  for (i = 0; i < width; i++)
    (*screen)[cury][curx++] = '-';
  kid += 2;

}
