/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */

#include <string.h>
#include "utils.h"
#include "variables.h"
#include "dim.h"

int
dimSubscript (char *found, char **Gpos, Tdim * Our, struct Tgraph *graph)
{
#define gpos (*Gpos)
#define our (*Our)
  char *start = found, *end, *tmp;
  Tdim out;

  *gpos = 1;			/* mark the superscript as #1#3 */
  gpos++;
  *gpos = 3;
  gpos++;
  *gpos = 0;

  end = findClosingBrace (start + 1);
  *end = 0;
  tmp = strdup (start + 1);
  *end = '}';
  out = dim (tmp, newChild (graph));
  free (tmp);
  if (out.y > our.baseline)
    {
      our.baseline = out.y;
      our.y += out.y;
    }
  if (graph->txt >= gpos - 4)	/* check if we had a superscript before */
    {
      if ((*(gpos - 4) == 1) && (*(gpos - 3) == 2))	/* yep, we had it */
	{
	  int width = graph->down[graph->children - 1]->dim.x;
	  if (width < out.x)
	    our.x += out.x - width;
	}
      else
	our.x += out.x;
    }
  else
    our.x += out.x;
  return end - (found - 1);
#undef gpos
#undef our
}

void
drawSubscript (int *Kid, int *Curx, int *Cury, char ***screen, struct Tgraph *graph, char *txt)
{
#define kid (*Kid)
#define curx (*Curx)
#define cury (*Cury)
  int width = graph->down[kid]->dim.x;
  if (txt - 3 >= graph->txt)
    {
      if ((*(txt - 3) == 1) && (*(txt - 2) == 2))
	{
	  drawInternal (screen, graph->down[kid], curx - (graph->down[kid - 1]->dim.x), cury + 1);
	  if (width > graph->down[kid - 1]->dim.y)
	    curx += width - graph->down[kid - 1]->dim.y;
	}
      else
	{
	  drawInternal (screen, graph->down[kid], curx, cury + 1);
	  curx += width;
	}
    }
  else
    {
      drawInternal (screen, graph->down[kid], curx, cury + 1);
      curx += width;
    }
  kid++;

}
