/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include "utils.h"
#include <stdio.h>
#include <string.h>

char *
getbegin_endEnd (char *txt)
{
  int len = strlen (txt);
  char *tmp1 = strstr (txt, "\\begin");
  char *tmp2 = strstr (txt, "\\end");
  while ((tmp1 < tmp2) && (tmp1 != NULL))
    {
      tmp2 = strstr (tmp2 + 4, "\\end");
      tmp1 = strstr (tmp1 + 6, "\\begin");
    }
  return tmp2;			/* return a pointer to the `\' letter of final \end */
}

char *
preparse (char *txt)
{
  char *result = (char *) malloc (strlen (txt) * 3);
  char *ptr = txt;
  char *rptr = result;
  while (*ptr)
    {
      if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/') && (*ptr != '*'))
	{
	  *rptr = *ptr;
	  rptr++;
	  ptr++;
	}
      else
	{
	  *rptr = ' ';
	  rptr++;
	  *rptr = *ptr;
	  rptr++;
	  *rptr = ' ';
	  rptr++;
	  ptr++;
	}
      if (((*(ptr - 1) == '^') || (*(ptr - 1) == '_')) && (*ptr != '{'))
	/* handle unbraced characters on su*scripts 
	   THIS IS VERY PRIMITIVE!!! (eg. fails with
	   123^\alpha (will convert to 123^{\}alpha) */
	{
	  if ((ptr - 2 < txt) || (*(ptr - 2) != '\\'))
	    {
	      *rptr = '{';
	      rptr++;
	      *rptr = *ptr;
	      rptr++;
	      *rptr = '}';
	      rptr++;
	      ptr++;
	    }
	}
    }
  *rptr = 0;
  result = (char *) realloc (result, strlen (result) + 1);
  return result;
}

char *
findClosingBrace (char *txt)
{
  int opened = 1;
  int len = strlen (txt);
  int i;
  for (i = 0; i < len; i++)
    {
      if (txt[i] == '{')
	opened++;
      if (txt[i] == '}')
	opened--;
      if (opened == 0)
	return txt + i;
    }
  fprintf (stderr, "Couldn't find matching brace in %s\n", txt);
  exit (1);
}

struct Tgraph *
newChild (struct Tgraph *graph)
{
  if (graph->children == 0)
    graph->down = (struct Tgraph **) malloc (sizeof (struct Tgraph *));
  else
    graph->down = (struct Tgraph **) realloc (graph->down, sizeof (struct Tgraph **) * (graph->children + 1));
  graph->down[graph->children] = (struct Tgraph *) malloc (sizeof (struct Tgraph));
  graph->down[graph->children]->up = graph;	/* setup the parent */
  graph->children++;
  return graph->down[graph->children - 1];
}
